/*
 * adl_rawgenerator.c -- a silly tool to generate data for the raw device
 *
 * Copyright (C) 1998   rubini@linux.it (Alessandro Rubini)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

int main(int argc, char **argv)
{
    FILE *f=NULL;
    char *device;
    int count=1;
    int *data;
    int i, j, len;
    char trash[24];

    if (argc<2) {
        fprintf(stderr,"Use: %s [-count] byte [byte ...]\n",argv[0]);
        exit(1);
    }
    device=getenv("ADLDEVICE");
    if (!device) {device="<stdout>"; f=stdout;}
    fprintf(stderr,"%s: using %s as output device\n",argv[0],device);
    if (!f)
        f=fopen(device,"w");
    if (!f) {
        fprintf(stderr,"%s: %s: %s\n",argv[0],device,strerror(errno));
        exit(1);
    }
    if (argv[1][0]=='-') {
        count = atoi(argv[1]+1);
        fprintf(stderr,"%s: count is %i\n",argv[0],count);
        argv++; argc--;
    }
    len=argc-1;
    data=malloc(len*sizeof(int));
    for (i=0; i<len; i++) {
        if (sscanf(argv[i+1],"%x%s",&j,trash)!=1) {
            fprintf(stderr,"Not an ex number \"%s\"\n",argv[i+1]);
            exit(1);
        }
        data[i]=j;
    }
    i=0;
    do 
        fwrite(data,sizeof(int),len,f);
    while (++i!=count);

    fclose(f);
    exit(0);
}
